# Palomino Flight Simulator - Manual

http://www.palomino3d.org

## Index

- Keyboard
- Command-line Args
- Configuration Files
- Joystick
- Problems

## Keyboard

Mod key: | Mod key is any of Shift/Ctrl/Alt. Using Shift is suggested unless the window manager reserves that key combination.
CTRL-c | exit program
TAB, ` (back-tick) | TAB: cycle view mode, ` (back-tick) switch control to chase-view to next view
cursor left | right | roll manipulator-mode : move left/right, Mod-Left/Right : yaw
cursor up | down | pitch manipulator-mode : move forward/backward, Mod-Up/Down : pitch
PageUp | PageDown | manipulator-mode : move up/down
key-pad: Ins | Del | yaw
key-pad: arrows | OTW view: change direction, chase-view: rotate
key-pad: - + 5/center | chase-view: zoom-in, zoom-out, reset
- = 0..9 | throttle
BACKSPACE | DELETE | reset program manipulator-mode : restore default viewpoint
g | landing gear
b | brakes
SPACE | fire weapon manipulator-mode: SPACE: restore viewpoint manipulator-mode: Mod-SPACE: save viewpoint
t | switch targets
'[' ']' or joystick buttons 4,5 | swing wings (F-14 Tomcat) or bay-doors (Space Shuttle)
F1 | start GUI
F5, Mod-F5 | F5: plays a replay. Mod-F5: starts recording a new replay Mod-F5 again: stops recording and saves to file.
F8, Mod-F8 | cycle brightness
F9 | toggle automatic coordinated-turn (propeller aircraft)
Mod-F9 | toggle wireframe mode
F10 | toggle stalling
Mod-F11 | reload scene-graph
F12 | display OSG statistics, Mod-F12 to dump scene graph to file

## Command-line Args

Args override preceding args and any counterparts in the configuration file.

### Args - Game

-spitfire -corsair -p51 -f86 -f14 -f15 -f16 -f18 -sr71 -mirage -su37 | Select aircraft model.
-coturn -no-coturn | Whether program should automatically coordinate a turn for player.
-takeoff -front-slot -rear-slot | Begin at takeoff, specify which slot on aircraft carrier.
-no-physics -no-stall | Disable physics, disable aircraft stalling.
-hour | Set time-of-day.
-cheat or -wimp | Disable game mode (no enemies).

### Args - Display

-wh width height | Set window size.
-brightness float | 1.0 is normal.

### Args - Features

-no-light | Disable lighting.
-no-shaders | Disable shaders.
-no-shadows -fast-shadows -soft-shadows | Soft shadows are slower.
-motion-blur or -no-motion-blur | Doesn't work on all video cards.
-no-sky -fog -no-fog -no-clouds | Control atmosphere.
-no-weather -weather -rain -snow | Control weather.

### Args - Sound

-no-sound or -ns | Disable sound.
-song filename -song-volume float | Play a theme song (if sound library is capable).

### Args - Performance

-fast | Gains speed but loses rendering quality and capabilities.
-speed n | Change simulation speed (time compression or fast-motion).
-timer-gettimeofday | Force using specific time functions.

### Args - Joystick

-j (or any -j* arg) | Enable joystick.
-jn number | Select joystick by number (if supported). 0 is the first joystick.
-jp | Print joystick values for calibration.
-jc confFile | Load joystick configuration from file.
-jlinux -jwindows | Use specific joystick driver.

### Args - Special Modes

-debug or -gdb | Enable trapping to debugger if assert fails (if compiled with DEBUG=1).
-t | Enable manipulator mode (for testing or constructing a scene).
-wire | Render in wireframe mode.
-dump-full | Dump as much as possible of the scene-graph (consumes more memory).

### Args - System Specific and Optional

-no-stats | Disable OSG statistics.
-no-osg-opt | Disable OSG optimizer.
-no-sdl | Disable SDL.

## Configuration Files

### data/palomino.conf

User-editable configuration file (subject-to-change in future versions).

### ~/.palomino

Not user-editable.
This subdirectory of the user's home directory contains binary data files (configuration, replay, etc).

## Joystick

Program can use 4 joystick axises: roll, pitch, yaw, throttle.

Where available, program can use SDL, Linux, or Windows joystick drivers.

Joystick and aircraft maneuverability have separate configurations.
Rate-of-roll/pitch/yaw is defined by data/physics_*.conf in degrees/second.

### Enabling Joystick

Pass -j to enable joystick.
Pass -jn n to select which joystick if more than one is connected.

### Calibrating Joystick

Pass -jp to print joystick values in order to calibrate joystick. Then edit data/joystick.conf.
Pass -jc [filename] to specify pathname to your custom joystick configuration file ("joystick.conf").

### Joystick Problems:

- Delayed reaction to joystick input:
  Try adjusting JoystickInputQueueOverflow or JoystickTickFreq in .conf.
- Linux: Try `modprobe joydev` or running as root.
- FreeBSD: Try installing SDL or the port devel/linux-js.
  linux-js emulates a Linux joystick driver at /dev/input/js0

## Problems

- Before reporting a problem:

To isolate the problem, try disabling features:
-no-sdl or -no-sound or -no-shaders etc
Also try editing the top-level CMakeLists.txt to compile without optional libraries.
Or try a different system.

- If GUI doesn't show:

Then the GUI wasn't compiled. To compile it, FTLK is required. cmake should show:
`-- Found FLTK: /usr/lib/libfltk.so`

- Fails to load 3D models (OSG plugin error):

Ensure that LD_LIBRARY_PATH (DYLD_LIBRAY_PATH Apple Mac) points to OSG plugin libraries:
/usr/local/lib/osgPlugins-N.N.N

- If graphics window has artifacts or mis-renders:

Try disabling options in this order:

1. -no-motion-blur
2. -no-osg-opt

- "there is no soundcard" yet sound works (printed by MIDI module of SDL, disregard it).

© 2004,2009 Jim Brooks http://www.palomino3d.org
Last modified: Fri Feb 5 14:47:21 CST 2010